		LIST	P=16F84A

PORTA	equ	05H
PORTB	equ	06H
TRISA	equ	85H
TRISB	equ	86H
INTCON	equ	0BH
OPTIO	equ	81H	
STATUS	equ	03H
	

RP0		equ	5		;(STATUS) bit prepinani banku registru		
C		equ	0		;(STATUS) priznak carry
DC		equ	1		;(STATUS) - BCD carry
Z		equ	2		;(STATUS) priznak zero
RTIF	equ	2		;(INTCON) priznak preteceni od RTCC

w		equ	0		
f		equ	1	

;(PORTB) ovladani katod displeju
D0		equ	0		
D1		equ	1
D2		equ	2
D3		equ	3

;(PORTB) tlacitka
PL		equ	4		;tl. plus
MI		equ	5		;tl. minus
ST		equ	6		;tl. set	

OUTP	equ	7		;(PORTB) ovladani motoru
IN		equ	4		;(PORTA) vstup snimace

;reg. cislic displeju
JEDDES	equ	14H		;jednotky a desitky disp.
STOTIS	equ	15H		;stovky a tisice disp.
NJD		equ	18H		;zde se uklada nastavene cislo - pocet zavitu
NST		equ	19H
		

		
PBLIK	equ	.200	;konstanty pro blikani displeje
DZHAS	equ	.50
	
BDISP	equ 10H		;b0-b3 - pokud '1' povoleni blikani prislusne cislovky, b4 - inc/dec 0-dec. 1-inc
INCDEC	equ	4
TBLIK	equ	11H		;casovani blikani displeje
REGIO	equ	12H		;pom. registr pro scan portu

BCK		equ	13H		;zalohovaci registr
BCK1	equ	1AH
CAS0	equ	17H		;cekaci reg pro scan portu
CAS1	equ	16H
		
		
		org		00H
		goto	INIT

		org		04H			;vektor preruseni je na adrese 04h

;;*** vlastni preruseni se stara o obsluhu displeje
INT		movwf	BCK
		movfw	STATUS
		movwf	BCK1

		decfsz	TBLIK		;casovani blikani displeje
		goto	DB0
		movlw	PBLIK		;konstanta pro periodu blikani displeje (k*perioda_preruseni)	
		movwf	TBLIK			
DB0		movfw	TBLIK
		sublw	DZHAS		;doba zhasnuti displeje

		btfss	PORTB,D0	
		goto	SD1
		bcf		PORTB,D0	;zobrazeni na D1
		btfss	BDISP,D1	;blikat displej?
		goto	LP00
		btfss	STATUS,C	;testuj carry z op. casovani dipsleje
		goto	LP00		;blikani - sviti
		movlw	b'00001111'	;blikani - nesviti
		iorwf	PORTA,f		
		goto	LP01

LP00	movlw	0F0H			;vynuluj bity na dekoder
		andwf	PORTA,f
		swapf	JEDDES,w
		andlw	0FH
		iorwf	PORTA,f		

LP01	bsf		PORTB,D1
		goto	OUT

SD1		btfss	PORTB,D1
		goto	SD2
		bcf		PORTB,D1	;zobrazeni na D2
		btfss	BDISP,D2	;blikat displej?
		goto	LP10
		btfss	STATUS,C	;testuj carry z op. casovani dipsleje
		goto	LP10		;blikani - sviti
		movlw	b'00001111'	;blikani - nesviti
		iorwf	PORTA,1		
		goto	LP11

LP10	movlw	0F0H			;vynuluj bity na dekoder
		andwf	PORTA,f
		movfw	STOTIS			;zobraz stovky na D2
		andlw	0FH
		iorwf	PORTA,f

LP11	bsf		PORTB,D2
		goto	OUT

SD2		btfss	PORTB,D2
		goto	SD3
		bcf		PORTB,D2	;zobrazeni na D3
		btfss	BDISP,D3	;blikat displej?
		goto	LP20
		btfss	STATUS,C	;testuj carry z op. casovani dipsleje
		goto	LP20
		movlw	b'00001111'	;blikani - nesviti
		iorwf	PORTA,1		
		goto	LP21

LP20	movlw	0F0H		;vynuluj bity na dekoder
		andwf	PORTA,f
		swapf	STOTIS,w	;zobraz tisice na D3
		andlw	0FH
		iorwf	PORTA,f

LP21	bsf		PORTB,D3
		goto	OUT

SD3		btfss	PORTB,D3
		goto	OUT
		bcf		PORTB,D3	;zobrazeni na D0
		btfss	BDISP,D0	;blikat displej?
		goto	LP30
		btfss	STATUS,C	;testuj carry z op. casovani dipsleje
		goto	LP30
		movlw	b'00001111'	;blikani - nesviti
		iorwf	PORTA,1		
		goto	LP31

LP30	movlw	0F0H			;vynuluj bity na dekoder
		andwf	PORTA,f
		movfw	JEDDES			;zobraz jednotky na D0
		andlw	0FH
		iorwf	PORTA,f
		

LP31	bsf		PORTB,D0
		goto	OUT		
		
OUT		movfw	BCK1
		movwf	STATUS
		movfw	BCK			
		bcf		INTCON,RTIF		
		retfie

;; *** inicializace promennych programu
INIT	bsf		STATUS,RP0	;banka 1
		movlw	b'00010000'
		movwf	TRISA		;portA - b0-b3 vystup na BCD dekoder, 4bit vstup snimace
		movlw	b'01110000'	
		movwf	TRISB		;portB - b0-b3 vystup pro multiplex, 4-6bit vstup tlacitek, 7bit vystup ovladani motoru navijecky
		movlw	b'00000011'
		movwf	OPTIO		;pull-up na portB povolen, zdroj pto preruseni fosc/4
		bcf		STATUS,RP0	;banka 0
		movlw	b'10100000'
		movwf	INTCON		;povoleni preruseni od RTCC
		clrf	PORTA
		clrf	PORTB		;vypnout vsechny vystupy
		clrf	BDISP
		bsf		PORTB,D0	;rozsvit cislovku D0
		movlw	PBLIK			
		movwf	TBLIK		;perioda blikani displeje
		movlw	b'00000001'	;po resetu zacit blikat jednotky
		movwf	BDISP
		clrf	STOTIS
		clrf	JEDDES

;; *** hlavni smyscka programu - obsluha tlacitek, pocitani impulzu
START	btfss	PORTB,ST	;tlacitko SET
		goto	sett
		btfss	PORTB,PL	;tlacitko PLUS
		goto	PLUS
		btfss	PORTB,MI
		goto	minus		
		GOTO	START

;obsluha stisku SET
sett	call	SCANKL

		movfw	BDISP
		andlw	0FH					
		XORLW	0FH				;test jestli blika cely displej -> 
		btfss	STATUS,Z		;po stisku SET nasleduje pocitani impulzu z cidla navijecky
		goto	DC0
		movlw	0F0H			;neblikat displej
		andwf	BDISP,f

;; *** obsluha pocitani impulzu
		bsf		PORTB,OUTP		;zapnout motor navijecky

CNTIMP  btfsc	BDISP,INCDEC	;test zda je napocitane cislo konecne
		goto	CNTIMP2
		call	TESTNUL
		btfsc	STATUS,Z	
		goto	KONEC
		goto	CNTIMP1
CNTIMP2	call	TESTNUM
		btfsc	STATUS,Z
		goto	KONEC
		
CNTIMP1	btfsc	PORTA,IN
		goto	CNTIMP1
CNTIMP0	btfss	PORTA,IN		;cekej na uvolneni snimace
		goto	CNTIMP0

		btfsc	BDISP,INCDEC	;inc/dec?
		goto	INKREM	
;dekrementalni pocitani
		movlw	0FH
		andwf	JEDDES,w		
		btfsc	STATUS,Z		;je tam nula?
		goto	DD0
		decf	JEDDES,f			
		goto	CNTIMP
DD0		movlw	0F0H
		andwf	JEDDES,f
		movlw	.9
		iorwf	JEDDES,f
		swapf	JEDDES,w
		andlw	0FH
		btfsc	STATUS,Z		;je tam nula?
		goto	DD1
		movlw	.16
		subwf	JEDDES,f
		goto	CNTIMP
DD1		movlw	0FH
		andwf	JEDDES,f
		movlw	90H
		iorwf	JEDDES,f
		movlw	0FH
		andwf	STOTIS,w
		btfsc	STATUS,Z		;je tam nula?
		goto	DD2
		decf	STOTIS,f
		goto	CNTIMP
DD2		movlw	0F0H
		andwf	STOTIS,f
		movlw	.9
		iorwf	STOTIS,f
		movlw	.16
		subwf	STOTIS,f
		goto	CNTIMP
INKREM	;inkrementalni pocitani

		movfw	JEDDES
		andlw	0FH
		sublw	.9				;je tam 9?
		btfsc	STATUS,Z
		goto	ID0
		incf	JEDDES,f		
		
		goto	CNTIMP

ID0		movlw	0F0H
		andwf	JEDDES,f
		swapf	JEDDES,w
		andlw	0FH
		sublw	.9
		btfsc	STATUS,Z
		goto	ID1
		movlw	.16
		addwf	JEDDES,f
		goto	CNTIMP

ID1		clrf	JEDDES	
		movlw	0FH
		andwf	STOTIS,w
		sublw	.9
		btfsc	STATUS,Z
		goto	ID2
		incf	STOTIS,f
		goto	CNTIMP

ID2		movlw	0F0H
		andwf	STOTIS,f
		movlw	.16
		addwf	STOTIS,f
		goto	CNTIMP

;; *** pomocne procedury
TESTNUL	movf	JEDDES,f		;test, zda jsou poc. reg v nule
		btfss	STATUS,Z	
		return
		movf	STOTIS,f
		return
		
TESTNUM	movfw	NJD				;test, zda jsou poc. reg na limitu
		subwf	JEDDES,w
		btfss	STATUS,Z
		return
		movfw	NST
		subwf	STOTIS,w
		return

;; *** konec pocitani
KONEC	bcf		PORTB,OUTP		;vypnout motor navijecky
		movlw	0FH
		movwf	BDISP		
LOOP	goto	LOOP

;; *** blikani nasledujici cifry po stisku SET
DC0		btfss	BDISP,D0
		goto	DC1
		bcf		BDISP,D0
		bsf		BDISP,D1
		goto	DC4

DC1		btfss	BDISP,D1
		goto	DC2
		bcf		BDISP,D1
		bsf		BDISP,D2
		goto	DC4

DC2		btfss	BDISP,D2
		goto	DC3
		bcf		BDISP,D2
		bsf		BDISP,D3
		goto	DC4

DC3		btfss	BDISP,D3
		goto	DC4
		bcf		BDISP,D3
		movlw	0FH
		movwf	BDISP		;rozblikat cely displej - nastaveni modu (inc/dec)
		movfw	JEDDES		;ulozit nastavene cislo
		movwf	NJD			
		movfw	STOTIS		;ulozit nastavene cislo
		movwf	NST
		
DC4		btfss	PORTB,ST
		goto	DC4
		call	SCANKL
		goto	START

sett0	btfss	PORTB,ST
		goto	sett0
		call	SCANKL
		goto	START


;; *** obsluha stisku PLUS
PLUS	call	SCANKL

		movfw	BDISP
		andlw	0FH					
		XORLW	0FH				;test jestli blika cely displej -> 
		btfss	STATUS,Z		;nasleduje nastaveni inc/dec
		goto	P0

		btfsc	BDISP,INCDEC	;testuj aktualni nastaveni
		goto	INC0		
		clrf	JEDDES
		clrf	STOTIS
		bsf		BDISP,INCDEC	
		goto 	PLUS0

INC0	movfw	NJD				;nastaveni rezimu inc/dec
		movwf	JEDDES
		movfw	NST
		movwf	STOTIS
		bcf		BDISP,INCDEC
		goto	PLUS0

P0		btfss	BDISP,D0
		goto	P1
		movfw	JEDDES
		andlw	0FH
		sublw	.9
		btfsc	STATUS,Z
		goto	PLUS0
		incf	JEDDES,f		
		goto	PLUS0
		
P1		btfss	BDISP,D1
		goto	P2
		swapf	JEDDES,w
		andlw	0FH
		sublw	.9
		btfsc	STATUS,Z
		goto	PLUS0
		movlw	.16
		addwf	JEDDES,f
		goto	PLUS0

P2		btfss 	BDISP,D2
		goto	P3
		movfw	STOTIS
		andlw	0FH
		sublw	.9
		btfsc	STATUS,Z
		goto	PLUS0
		incf	STOTIS,f	
		goto	PLUS0

P3		btfss	BDISP,D3
		goto	PLUS0
		swapf	STOTIS,w
		andlw	0FH
		sublw	.9
		btfsc	STATUS,Z
		goto	PLUS0
		movlw	.16
		addwf	STOTIS,f

PLUS0	btfss	PORTB,PL
		goto	PLUS0
		call	SCANKL
		goto	START

;obsluha stisku MINUS
minus	call 	SCANKL
		movfw	BDISP
		andlw	0FH					
		XORLW	0FH				;test jestli blika cely displej -> 
		btfss	STATUS,Z		;nasleduje nastaveni inc/dec
		goto	M0

		btfsc	BDISP,INCDEC	;testuj aktualni nastaveni
		goto	DEC0		
		clrf	JEDDES
		clrf	STOTIS
		bsf		BDISP,INCDEC	
		goto 	MINUS0

DEC0	movfw	NJD				;nastaveni rezimu inc/dec
		movwf	JEDDES
		movfw	NST
		movwf	STOTIS
		bcf		BDISP,INCDEC
		goto	MINUS0
	
M0		btfss	BDISP,D0
		goto	M1
		movfw	JEDDES
		andlw	0FH
		btfsc	STATUS,Z
		goto	MINUS0
		decf	JEDDES,f			
		goto	MINUS0
		
M1		btfss	BDISP,D1
		goto	M2
		swapf	JEDDES,w
		andlw	0FH
		btfsc	STATUS,Z
		goto	MINUS0
		movlw	.16
		subwf	JEDDES,f
		goto	MINUS0
		
M2		btfss 	BDISP,D2
		goto	M3
		movfw	STOTIS
		andlw	0FH
		btfsc	STATUS,Z
		goto	MINUS0
		decf	STOTIS,f		
		goto	MINUS0

M3		btfss	BDISP,D3
		goto	MINUS0
		swapf	STOTIS,w
		andlw	0FH
		btfsc	STATUS,Z
		goto	MINUS0
		movlw	.16
		subwf	STOTIS,f
		
MINUS0	btfss	PORTB,MI
		goto	MINUS0
		call	SCANKL
		goto	START

; *** osetreni zakmitu tlacitek
SCANKL	movfw	PORTB
		andlw	b'01110000'
		movwf	REGIO
		call	CEKEJ
		movfw	PORTB
		andlw	b'01110000'
		subwf	REGIO,w
		btfsc	STATUS,Z
		return	
		goto	SCANKL

CEKEJ	movlw	.100
		movwf	CAS0
		movlw	.50
		movwf	CAS1
CEK1	decfsz	CAS0,f
		goto	CEK1
		movfw	CAS1
		btfsc	STATUS,Z		
		return		
		decf	CAS1,f
		goto	CEK1

		END
